(******************************************************************************)
(* generator (stack machine)                                                  *)
(* (C) 2010 Steffen Solyga <solyga@absinth.net>                               *)
(******************************************************************************)
DEFINITION MODULE Gen;

IMPORT Comp0;

TYPE
  TValue   = Comp0.TValue;
  TIndex   = Comp0.TIndex;
  TAddress = Comp0.TAddress;

  TOp1 = ( oNeg, oNot );
  TOp2 = (
    oNull,
    oAdd, oSub, oMul, oDiv, oOr,  oAnd,
    oEql, oNeq, oLss, oLeq, oGtr, oGeq
  );

  TType = ( tBool, tInt );
  TMode = ( mConst, mVar, mStack );
  TItemDesc = RECORD
    t: TType;
    CASE m: TMode OF
    | mConst: v: TValue;
    | mVar  : i: TIndex;
    | mStack:
    END;
  END;

PROCEDURE Hlt();

PROCEDURE Wrt( x: TItemDesc );
PROCEDURE Op1( o: TOp1; VAR x: TItemDesc );
PROCEDURE Op2( o: TOp2; VAR x: TItemDesc; y: TItemDesc );
PROCEDURE Asg( x, y: TItemDesc );

PROCEDURE Label( VAR a: TAddress );
PROCEDURE Jmp( a: TAddress );
PROCEDURE Jpf( a: TAddress; x: TItemDesc );

PROCEDURE Init( VAR a: TAddress );
PROCEDURE JmpFwd( VAR a: TAddress );
PROCEDURE JpfFwd( VAR a: TAddress; x: TItemDesc );
PROCEDURE Fixup( a: TAddress );

CONST
  vFalse = Comp0.vFalse;
  vTrue  = Comp0.vTrue;

END Gen.
